=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class UPSCreateMasterAccountParameters
    attr_accessor :billing_address_city

    attr_accessor :billing_address_country_iso2

    attr_accessor :billing_address_state

    attr_accessor :billing_address_street1

    # Empty string acceptable for billing_address_street2
    attr_accessor :billing_address_street2

    attr_accessor :billing_address_zip

    # Company name. Full name is acceptable in this field if the user has no company name
    attr_accessor :company

    attr_accessor :email

    attr_accessor :full_name

    # Needs to be a valid phone number and cannot be null
    attr_accessor :phone

    # User's pickup address city.
    attr_accessor :pickup_address_city

    # User's pickup street 1.
    attr_accessor :pickup_address_country_iso2

    attr_accessor :pickup_address_same_as_billing_address

    # User's pickup address state.
    attr_accessor :pickup_address_state

    # User's pickup address street 1.
    attr_accessor :pickup_address_street1

    # User's pickup street 2.
    attr_accessor :pickup_address_street2

    # User's pickup address zip code.
    attr_accessor :pickup_address_zip

    # Whether the user agrees to the UPS terms and conditions or not. Error 400 will be returned if passed in as false
    attr_accessor :ups_agreements

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'billing_address_city' => :'billing_address_city',
        :'billing_address_country_iso2' => :'billing_address_country_iso2',
        :'billing_address_state' => :'billing_address_state',
        :'billing_address_street1' => :'billing_address_street1',
        :'billing_address_street2' => :'billing_address_street2',
        :'billing_address_zip' => :'billing_address_zip',
        :'company' => :'company',
        :'email' => :'email',
        :'full_name' => :'full_name',
        :'phone' => :'phone',
        :'pickup_address_city' => :'pickup_address_city',
        :'pickup_address_country_iso2' => :'pickup_address_country_iso2',
        :'pickup_address_same_as_billing_address' => :'pickup_address_same_as_billing_address',
        :'pickup_address_state' => :'pickup_address_state',
        :'pickup_address_street1' => :'pickup_address_street1',
        :'pickup_address_street2' => :'pickup_address_street2',
        :'pickup_address_zip' => :'pickup_address_zip',
        :'ups_agreements' => :'ups_agreements'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'billing_address_city' => :'Object',
        :'billing_address_country_iso2' => :'Object',
        :'billing_address_state' => :'Object',
        :'billing_address_street1' => :'Object',
        :'billing_address_street2' => :'Object',
        :'billing_address_zip' => :'Object',
        :'company' => :'Object',
        :'email' => :'Object',
        :'full_name' => :'Object',
        :'phone' => :'Object',
        :'pickup_address_city' => :'Object',
        :'pickup_address_country_iso2' => :'Object',
        :'pickup_address_same_as_billing_address' => :'Object',
        :'pickup_address_state' => :'Object',
        :'pickup_address_street1' => :'Object',
        :'pickup_address_street2' => :'Object',
        :'pickup_address_zip' => :'Object',
        :'ups_agreements' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::UPSCreateMasterAccountParameters` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::UPSCreateMasterAccountParameters`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'billing_address_city')
        self.billing_address_city = attributes[:'billing_address_city']
      end

      if attributes.key?(:'billing_address_country_iso2')
        self.billing_address_country_iso2 = attributes[:'billing_address_country_iso2']
      end

      if attributes.key?(:'billing_address_state')
        self.billing_address_state = attributes[:'billing_address_state']
      end

      if attributes.key?(:'billing_address_street1')
        self.billing_address_street1 = attributes[:'billing_address_street1']
      end

      if attributes.key?(:'billing_address_street2')
        self.billing_address_street2 = attributes[:'billing_address_street2']
      end

      if attributes.key?(:'billing_address_zip')
        self.billing_address_zip = attributes[:'billing_address_zip']
      end

      if attributes.key?(:'company')
        self.company = attributes[:'company']
      end

      if attributes.key?(:'email')
        self.email = attributes[:'email']
      end

      if attributes.key?(:'full_name')
        self.full_name = attributes[:'full_name']
      end

      if attributes.key?(:'phone')
        self.phone = attributes[:'phone']
      end

      if attributes.key?(:'pickup_address_city')
        self.pickup_address_city = attributes[:'pickup_address_city']
      end

      if attributes.key?(:'pickup_address_country_iso2')
        self.pickup_address_country_iso2 = attributes[:'pickup_address_country_iso2']
      end

      if attributes.key?(:'pickup_address_same_as_billing_address')
        self.pickup_address_same_as_billing_address = attributes[:'pickup_address_same_as_billing_address']
      end

      if attributes.key?(:'pickup_address_state')
        self.pickup_address_state = attributes[:'pickup_address_state']
      end

      if attributes.key?(:'pickup_address_street1')
        self.pickup_address_street1 = attributes[:'pickup_address_street1']
      end

      if attributes.key?(:'pickup_address_street2')
        self.pickup_address_street2 = attributes[:'pickup_address_street2']
      end

      if attributes.key?(:'pickup_address_zip')
        self.pickup_address_zip = attributes[:'pickup_address_zip']
      end

      if attributes.key?(:'ups_agreements')
        self.ups_agreements = attributes[:'ups_agreements']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @billing_address_city.nil?
        invalid_properties.push('invalid value for "billing_address_city", billing_address_city cannot be nil.')
      end

      if @billing_address_country_iso2.nil?
        invalid_properties.push('invalid value for "billing_address_country_iso2", billing_address_country_iso2 cannot be nil.')
      end

      if @billing_address_state.nil?
        invalid_properties.push('invalid value for "billing_address_state", billing_address_state cannot be nil.')
      end

      if @billing_address_street1.nil?
        invalid_properties.push('invalid value for "billing_address_street1", billing_address_street1 cannot be nil.')
      end

      if @billing_address_zip.nil?
        invalid_properties.push('invalid value for "billing_address_zip", billing_address_zip cannot be nil.')
      end

      if @pickup_address_city.nil?
        invalid_properties.push('invalid value for "pickup_address_city", pickup_address_city cannot be nil.')
      end

      if @pickup_address_country_iso2.nil?
        invalid_properties.push('invalid value for "pickup_address_country_iso2", pickup_address_country_iso2 cannot be nil.')
      end

      if @pickup_address_state.nil?
        invalid_properties.push('invalid value for "pickup_address_state", pickup_address_state cannot be nil.')
      end

      if @pickup_address_street1.nil?
        invalid_properties.push('invalid value for "pickup_address_street1", pickup_address_street1 cannot be nil.')
      end

      if @pickup_address_zip.nil?
        invalid_properties.push('invalid value for "pickup_address_zip", pickup_address_zip cannot be nil.')
      end

      if @ups_agreements.nil?
        invalid_properties.push('invalid value for "ups_agreements", ups_agreements cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @billing_address_city.nil?
      return false if @billing_address_country_iso2.nil?
      return false if @billing_address_state.nil?
      return false if @billing_address_street1.nil?
      return false if @billing_address_zip.nil?
      return false if @pickup_address_city.nil?
      return false if @pickup_address_country_iso2.nil?
      return false if @pickup_address_state.nil?
      return false if @pickup_address_street1.nil?
      return false if @pickup_address_zip.nil?
      return false if @ups_agreements.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          billing_address_city == o.billing_address_city &&
          billing_address_country_iso2 == o.billing_address_country_iso2 &&
          billing_address_state == o.billing_address_state &&
          billing_address_street1 == o.billing_address_street1 &&
          billing_address_street2 == o.billing_address_street2 &&
          billing_address_zip == o.billing_address_zip &&
          company == o.company &&
          email == o.email &&
          full_name == o.full_name &&
          phone == o.phone &&
          pickup_address_city == o.pickup_address_city &&
          pickup_address_country_iso2 == o.pickup_address_country_iso2 &&
          pickup_address_same_as_billing_address == o.pickup_address_same_as_billing_address &&
          pickup_address_state == o.pickup_address_state &&
          pickup_address_street1 == o.pickup_address_street1 &&
          pickup_address_street2 == o.pickup_address_street2 &&
          pickup_address_zip == o.pickup_address_zip &&
          ups_agreements == o.ups_agreements
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [billing_address_city, billing_address_country_iso2, billing_address_state, billing_address_street1, billing_address_street2, billing_address_zip, company, email, full_name, phone, pickup_address_city, pickup_address_country_iso2, pickup_address_same_as_billing_address, pickup_address_state, pickup_address_street1, pickup_address_street2, pickup_address_zip, ups_agreements].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
